#!/usr/bin/env python
# coding: utf-8

# In[1]:


import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import math
import time
import random
import torch
from sklearn.model_selection import train_test_split, GridSearchCV
from sklearn.metrics import mean_squared_error
from sklearn.model_selection import KFold
from sklearn.metrics import r2_score
from sklearn.gaussian_process import GaussianProcessRegressor
from sklearn.gaussian_process.kernels import RBF, ConstantKernel as ConstantKernel
from sklearn.kernel_ridge import KernelRidge
from sklearn.neighbors import KNeighborsRegressor
from sklearn.decomposition import PCA
from sklearn.ensemble import RandomForestRegressor
from sklearn.preprocessing import StandardScaler
from sklearn.preprocessing import minmax_scale


# # Load data

# In[2]:


# load data
data = pd.read_excel('C:/Users/harve/OneDrive/Desktop/Genetic Algorithm/Ensemble learning/Original data/training dataset.xlsx')
temperature_index = ['T']
y = data[temperature_index]
print(y.describe())
# print(y.mean(axis=0))

fthick = ['fthick']
thick = data[fthick]
print(thick.mean(axis=0))

scaler = StandardScaler()
scaler.fit(y)
print(scaler.mean_)
print(scaler.var_)
T_norm = scaler.transform(y)


# Compare with jenny's data
data2 = pd.read_excel('C:/Users/harve/OneDrive/Desktop/Genetic Algorithm/Python program-Jenny/data_scaled.xlsx')
y_index = ['T']
T_norm2 = data2[y_index]

out = T_norm-T_norm2
out.sum(axis=0)

# outcome shows exactly the same


# # Rank data based on T

# In[3]:


new_y = y.rename(columns={'T':'TO'})
data3 = pd.concat([data2, new_y], join = 'outer', axis = 1)
data3


# In[4]:


data3.sort_values('TO')


# # Construct material systems

# In[5]:


fheatcap = data['fheatcap']
sheatcap = data['sheatcap']
fheatcap.describe()


# In[6]:


sheatcap.describe()


# In[7]:


#load descriptor data
des_data = pd.read_excel('C:/Users/harve/OneDrive/Desktop/Genetic Algorithm/Ensemble learning/Original data/descriptor dataset.xlsx')


# In[8]:


des_data


# In[9]:


des_data.describe()


# In[10]:


a = des_data[:2]
a = a.rename(columns=lambda s: 'f'+s)
a.reset_index(drop=True, inplace=True)
print(a.shape)
a


# In[11]:


all_entries = []
for i in range(298):
    for j in range(298):
        a = des_data[i:i+1]
        a = a.rename(columns=lambda s: 'f'+s)
        a.reset_index(drop=True, inplace=True)
        if i!=j:
            b = des_data[j:j+1]
            b = b.rename(columns=lambda s: 's'+s)
            b.reset_index(drop=True, inplace=True)
            c = pd.concat([a,b], axis=1)
            all_entries.append(c)
        else:
            continue
print(len(all_entries))


# In[12]:


ms = all_entries[0]
for i in range(1,len(all_entries)):
    ms = pd.concat([ms, all_entries[i]], axis=0)
ms
    
    


# In[13]:


ms.to_excel("output.xlsx")


# In[14]:


print('finished')


# In[15]:


test_data = pd.read_excel('C:/Users/harve/OneDrive/Desktop/Genetic Algorithm/Ensemble learning/Original data/test data - Copy.xlsx')


# In[ ]:




